/**
 * @(#)pms8.h 2009/10/03
 *
 * @author Tognon Stefano
 * @version 1.00
 *
 * This program automatically generates random magic squares of order 8
 * The sequence of number wil be read from file. Magic constant will be 
 * automatically calculated.
 * The square is printed in standard output, while the other information are
 * printed in standard error.
 *
 * note: some comments are in the style of Javadoc of Java language!
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307  USA.
 */

typedef unsigned int word;

#define DORDER 8
const int ORDER=DORDER;  // square order
const int COMB=256;      // 2 at pow of order
word MAGIC;             // magic constant (to calculate)

// number of max spaces between output values
const int MAX_BLANK=4;

// list of numbers (PRIME name is only for old compatibility)
word PRIME[ORDER*ORDER];

// this is a union of bits and the corresponding int value.
// if the program never produce results, probably your compiler manage this
// union in a different way. If we increase 'counter' then some bits may
// changes their value.
union unionBits {
  int counter;
  struct {
    unsigned bit0 :1;
    unsigned bit1 :1;
    unsigned bit2 :1;
    unsigned bit3 :1;
    unsigned bit4 :1;
    unsigned bit5 :1;
    unsigned bit6 :1;
    unsigned bit7 :1;
  } bit;
};

// note: these defines works ok with even order

#define UP_SEQ {0, 1, 2, 3, 4, 5, 6, 7}
#define DN_SEQ {7, 6, 5, 4, 3, 2, 1, 0}

#define IJ(a) (i==a || j==(ORDER-a-1) || j==a || i==(ORDER-a-1))

#define POS(a) (pos[a]!=a)
#define POSES   POS(0) && POS(1) && POS(2) && POS(3) && \
                POS(4) && POS(5) && POS(6) && POS(7)

#define VALUE(a) (sq.cell[pos[a]][a])
#define VALUES  (VALUE(0)+ VALUE(1)+ VALUE(2)+ VALUE(3)+ VALUE(4)+ \
                 VALUE(5)+  VALUE(6)+ VALUE(7))

#define IF_SWAP if (bits.bit.bit0) swap(sq, i, 0, j, 0); \
                if (bits.bit.bit1) swap(sq, i, 1, j, 1); \
                if (bits.bit.bit2) swap(sq, i, 2, j, 2); \
                if (bits.bit.bit3) swap(sq, i, 3, j, 3); \
                if (bits.bit.bit4) swap(sq, i, 4, j, 4); \
                if (bits.bit.bit5) swap(sq, i, 5, j, 5); \
                if (bits.bit.bit6) swap(sq, i, 6, j, 6); \
                if (bits.bit.bit7) swap(sq, i, 7, j, 7);

#define SUM_CELL sq.cell[index[bits.bit.bit0]][0]+ \
                 sq.cell[index[bits.bit.bit1]][1]+ \
                 sq.cell[index[bits.bit.bit2]][2]+ \
                 sq.cell[index[bits.bit.bit3]][3]+ \
                 sq.cell[index[bits.bit.bit4]][4]+ \
                 sq.cell[index[bits.bit.bit5]][5]+ \
                 sq.cell[index[bits.bit.bit6]][6]+ \
                 sq.cell[index[bits.bit.bit7]][7]

#define BIT_IJ (bits.bit.bit0 && IJ(0)) || \
               (bits.bit.bit1 && IJ(1)) || \
               (bits.bit.bit2 && IJ(2)) || \
               (bits.bit.bit3 && IJ(3)) || \
               (bits.bit.bit4 && IJ(4)) || \
               (bits.bit.bit5 && IJ(5)) || \
               (bits.bit.bit6 && IJ(6)) || \
               (bits.bit.bit7 && IJ(7))
